if(isObject(MirrorsGUI))
	MirrorsGUI.delete();
new GuiControl(MirrorsGUI)
{
	new GuiWindowCtrl(MirrorsUI)
	{
		position = "200 200";
		extent = "400 175";
		text = "Mirrors Control";
		
		accelerator = "Escape";
		command = "Canvas.popDialog(MirrorsGUI);";
		closeCommand = "Canvas.popDialog(MirrorsGUI);";
		
		new GuiTextCtrl(MirrorsText)
		{
			position = "30 155";
			text = "Mirror: 0 0 0   STABLE";
			
			controls = "N/A";
		};
	};
};

function AddMirrorsGroup(%pos, %num, %col)
{
	(%mainBtn = new GuiBitmapButtonCtrl()
	{
		position = getWords(vectorSub(%pos, "25 25"), 0, 1);
		extent = "50 50";
		controls = %num;
		text = "";
		
		bitmap = "Add-Ons/Client_Mirrors/Medium Circle";
		command = "Mirrors_Click($ThisControl);";
	}).setColor(%col);
	MirrorsUI.add(%mainBtn);
	%const = 1.25664;
	for(%i=0;%i<5;%i++)
	{
		%ang = %const * %i;
		%x = mFloatLength(mSin(%ang) * 50 + getWord(%pos, 0) - 12.5, 0);
		%y = mFloatLength(-mCos(%ang) * 50 + getWord(%pos, 1) - 12.5, 0);
		(%btn = new GuiBitmapButtonCtrl()
		{
			position = %x SPC %y;
			extent = "25 25";
			group = %num;
			text = "";
			bit = %i;
			
			bitmap = "Add-Ons/Client_Mirrors/Medium Circle";
			command = "Mirrors_Click($ThisControl);";
		}).setColor("0 0 0 1");
		MirrorsUI.add(%btn);
	}
}

AddMirrorsGroup("75 90", 0, "1 0 0 1");
AddMirrorsGroup("200 90", 1, "1 1 0 1");
AddMirrorsGroup("325 90", 2, "0 0 1 1");

function Mirrors_Click(%this)
{
	if(%this.controls !$= "")
	{
		%count = MirrorsUI.getCount();
		for(%i=0;%i<%count;%i++)
		{
			%obj = MirrorsUI.getObject(%i);
			if(%obj.group != %this.controls) continue;
			if(%obj.toggled) %btnsOn++;
		}
		for(%i=0;%i<%count;%i++)
		{
			%obj = MirrorsUI.getObject(%i);
			if(%obj.group != %this.controls) continue;
			%obj.toggled = %btnsOn < 3;
		}
	}
	else %this.toggled = !%this.toggled;
	Mirrors_Update();
}

function Mirrors_Update()
{
	%count = MirrorsUI.getCount();
	for(%i=0;%i<%count;%i++)
	{
		%obj = MirrorsUI.getObject(%i);
		if(%obj.controls !$= "") continue;
		%obj.setColor(%obj.toggled ? "1 1 1 1" : "0 0 0 1");
		if(%obj.toggled) %bit[%obj.group] += mPow(2, %obj.bit);
	}
	for(%i=0;%i<3;%i++)
		%val[%i] = Mirrors_BitsToFive(%bit[%i]);
	if(%val0 == 0) %stable = 1;
	if(%val1 + %val2 == 0) %stable = 1;
	if(%val0 + %val1 + %val2 == 93) %stable = 1;
	MirrorsText.setText("Mirror "@%val0 SPC %val1 SPC %val2@"   "@(%stable ? "STABLE" : "UNSTABLE"));
}

function Mirrors_FiveToBits(%val)
{
	%bits = "0 1 16 8 4 2 17 9 5 3 24 20 18 12 10 6 25 21 19 13 11 7 28 26 22 14 29 27 23 15 30 31";
	return getWord(%bits, %val);
}

function Mirrors_BitsToFive(%val)
{
	%five = "0 1 5 9 4 8 15 21 3 7 14 20 13 19 25 29 2 6 12 18 11 17 24 28 10 16 23 27 22 26 30 31";
	return getWord(%five, %val);
}

function openMirrorsGUI(%tog)
{ if(%tog) Canvas.pushDialog(MirrorsGUI); }

if(!$MirrorsHasBound)
{
	$MirrorsHasBound = 1;
	$remapDivision[$remapCount] = "Mirrors Client";
	$remapName[$remapCount] = "Mirrors GUI";
	$remapCmd[$remapCount] = "openMirrorsGUI";
	$remapCount++;
}